// GActiveObject.h: interface for the GActiveObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GACTIVEOBJECT_H__9C105360_5EE8_4EBC_8A6B_90C71F4DA2DC__INCLUDED_)
#define AFX_GACTIVEOBJECT_H__9C105360_5EE8_4EBC_8A6B_90C71F4DA2DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GObject.h"
#include "HCollisions.h"

class GAI;
class H3DModel;

class GActiveObject : public GObject  
{
public:

	virtual void Render();
	virtual void DoEvent();
	
	// provede rotaci a posunuti + pushmatrix. - vraci false, kdyz by se model nemel kreslit - diky
	// frustrum cullingu
	bool RenderRotoMovePushMatrix();
	
	GActiveObject(GEngine *engine, H3DModel *model3D);
	virtual ~GActiveObject();

	// inteligence pohybu (muze byt i clovek) - je nase vlasti - pro kazdy objekt unikatni kopie
	GAI   *m_ai;
	
	bool   m_active; // zda je objket aktivni - ma se pouzivat pri narazech,..... (treba kdyz panacek umre, tak je chvilku mimo hru)
	
  // nastavi AI
  virtual void SetAI(GAI *ai);
  
	// ukazatel na model, ktery se bude kreslit - propujceny ukazatel
	H3DModel *m_3Dmodel;

	// ovlada umela inteligence
	bool    m_up;       //  nahoru  Y++
	bool    m_down;     //  dolu    Y--
	bool    m_left;     //  doleva  X--
	bool    m_right;    //  doprava X++
	bool    m_forward;  //  dopredu Z++
	bool    m_backward; //  zpet    Z--
	float   m_rotY;     //  -360 ... 0 ... +360  - otoceni kolem osy Y
	                    //       levo  pravo    abs() == 2*PI - otoceni kolem dokola
	float   m_rotX;     //  -360 ... 0 ... +360  - otoceni kolem osy X
	                    //      nahoru  dolu    abs() == 2*PI- otoceni kolem dokola
	float   m_rotZ;     //  -360 ... 0 ... +360  - otoceni kolem osy Z
	                    // prevraceni vlevo  vprave    abs() == 2*PI - otoceni kolem dokola
							  
	// tohle bude asi jen pro Kulice 2 - urcije pohyb v 2D
	float  m_sin_alpha; // pro urceni smeru pohybu
	float  m_cos_alpha; 
	
	
	bool   m_action1;  // tohle zalezi na objektu a AI
	bool   m_action2;
	bool   m_action3;
	bool   m_action4;
	bool   m_action5;

	//TODO - mela by byt jeste jedna promena - na sliding a
	// k ni odpovidajici slide konstanta !!!!

	// souradnice
	CVector3 m_position;
	CVector3 m_model_position; // pozice, ke ktere je pricten sted modelu! - to je vlastne pak skutecna souradnice ve svete modelu

	// zmena pohybu
	CVector3 m_moveing;

	// smer, kterym by jsme chteli letet
	CVector3 m_req_movement;

	// rotace - natoceni objektu
	CVector3 m_rotation;

	// zmena pohybu vlivem "narazu" - pocita se s jinou konstantou pro pohyb...
	CVector3 m_sliding; 

	// smer pohybu po vsech vynasobenich a poscitanich
	CVector3 m_finalmoveing;
	
	// koeficient pri prepoctu m_moveing pomoci m_req_movement
	float    m_acceleration; 

	// koeficient pro "odolnost proti slidovani"
	float    m_antislide;  // <0.0, 1.0) 0.0 - nesliduje, 1.0 - total slider

	// rychlost objektu
	float    m_speed;

	// tady by se taky meli pripsat veci jako rozmery a hmotnost pro ucely kolize

   // volano, pokud vznikla kolize s jinym GActiveObject
   // vraci true, pokud je tvrdym objektem a je treba odstranit kolizni stav
   // false, pokud si objekt mysli, ze kolizni stav je OK
	// pokud je jako object zadano NULL, znamena to naraz do zdi!!!!
   virtual bool Hitted(GActiveObject *object);

   // rozmery objektu (obklopujici kvard)
	CVector3 m_size;     // tyhle 2 promene se pocitaji podle m_3Dmodel (opisuji se)
	// polomer obklopujici koule objektu
	float    m_radius;     
	
	// hmotnost objektu - nesmi byt 0, protoze se sni deli
	float    m_veight;   
	
	// stare udaje (ukladaji se pred zmenou souradnic)
	struct st_old{
		CVector3 m_position; // stara pozice
	} m_old;
	
	// udaje kolizniho systemu (aby slo objekty rychleji presouvat a nemuzelo se vse pokazde prepocitavat)
	st_CollisActiveObj m_collissys; // GActiveObject se o tuhle promenou vubec nestara!!!
};

#endif // !defined(AFX_GACTIVEOBJECT_H__9C105360_5EE8_4EBC_8A6B_90C71F4DA2DC__INCLUDED_)
