//KULIC2

//
// File: GEngineKulic.h
// Created by: berny <(null)>
// Created on: Wed Feb  5 08:06:28 2003
//

#include "ph.h"
#include "GEngineKulic.h"
#include "H3DModel2.h"
#include "GObject.h"
#include "GView.h"
#include "GBackGround.h"
#include "GActiveObject.h"
#include "GRun.h"

#include "GKulic.h"
#include "GShoot.h"
#include "GAI.h"
#include "GAI_Player_Mouse.h"
#include "GAI_Player2.h"
#include "GAI_Random.h"
#include "GKulicModel.h"

GEngineKulic::GEngineKulic(GRun *run) : GEngine(run)
{
#ifdef WANT_STATUS
	printf(gettext("Loading game models\n"));
#endif
	
	// nacitani modelu
	m_3Dmodel[0] = hmodel.LoadModel("c3.3ds", H3D_DL_MODEL);
	
	GShoot::PrepareShootParams();

	m_fog = true;
	m_eye_angle = 45.0f;   // uhel oka
	m_far_cliping = 2000.0f; // vzdalenost zadniho na clipping
	
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
	gluPerspective(m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, m_far_cliping);	// 1.0f - to se nesmi sdat < nez 1.0!!!
   glMatrixMode(GL_MODELVIEW);
	glFogf(GL_FOG_START, m_far_cliping - 200.0f);    
	glFogf(GL_FOG_END, m_far_cliping);    
	
}


GEngineKulic::~GEngineKulic()
{
	GShoot::DestroyShootParams();
}


bool GEngineKulic::StartGame()
{
	
#ifdef WANT_STATUS
	printf(gettext("Loading map\n"));
#endif

	// otestueje, zda se muze zacit hrat
	if (!gsetting.StartDataValid()) return false;
	
	// kopie parametru mapy a spusteni
	st_startgame sg = gsetting.m_startgame;
	m_map = gsetting.m_map[sg.mapID];

	// nastavei barvy mlhy
	glFogfv(GL_FOG_COLOR, m_map.fogColor);
	glClearColor(m_map.fogColor[0], m_map.fogColor[1], m_map.fogColor[2], 0.0f);	// Nastavime barvu pozadi na cernou
	
	
// pozadi
	GBackGround *back = new GBackGround(this);
	AddObject(back);

#ifdef WANT_STATUS
	printf(gettext("Creating collisions map\n"));
#endif
	
	m_collisions = new HCollisions(20, 20, 20, m_map.collis_model);
	

#ifdef WANT_STATUS
	printf(gettext("Creating players\n"));
#endif
	
// Nas Hrac	
	st_kulic_params par = GKulicParams[gsetting.m_char[sg.charID].paramsID];
	GKulic *pl1 = new GKulic(this, m_3Dmodel[0], &par);
	
	// nastaveni ovladani
	GAI *ai = NULL;
	ai = new GAI_Player_Mouse(this, pl1);
 	pl1->SetAI(ai);
	

	// pridani modelu kulice
	GKulicModel *km = new GKulicModel();
//	km->InitModels(NULL, &m_3Dmodel[0], &m_3Dmodel[10], 10, 500);
	km->InitModels(sg.charID, sg.skinID);
	pl1->m_kulicmodel = km;
	
  // nastaveni pozice
	pl1->m_position.x =  0;
	pl1->m_position.y =  0;
	pl1->m_position.z = -50;

	// pridani
	AddObject(pl1);
	
	m_view.Init(this, pl1);
	
// Dalsi stojici postava

	for (int i = 0; i < 6; i++) {
		int ch = rand()%gsetting.m_chars;
		par = GKulicParams[gsetting.m_char[ch].paramsID];
		pl1 = new GKulic(this, m_3Dmodel[0], &par);
	
		// nastaveni ovladani
		ai = new GAI_Random(this, pl1);
		pl1->SetAI(ai);

		// pridani modelu hrace
		km = new GKulicModel();
		km->InitModels(ch, rand()%gsetting.m_char[ch].skins);
		pl1->m_kulicmodel = km;
		
	  // nastaveni pozice
		pl1->m_position.x =  10-rand()%20;
		pl1->m_position.y =  0;
		pl1->m_position.z =  -10-rand()%35;

		// pridani
		AddObject(pl1);
	}
	
//	m_view.Init(this, pl1); // - tohle je dobre, kdyz chce clovek demo :-)
	
	
	m_objects_del = 0; // pocetr objektu na smazani

	m_paused = false; // preci nebudeme zacinat hru zapauzovanou :-)
	
	return true;
}

		
void GEngineKulic::KeyDown(Uint8 key)
{
	GEngine::KeyDown(key);

	switch (key) {
	case SDLK_u :
		if (--m_view.m_cameraID < 0) m_view.m_cameraID = MAX_CAMERA_SETTINGS;
		break;
	case SDLK_i :
		if (++m_view.m_cameraID > MAX_CAMERA_SETTINGS) m_view.m_cameraID = 0;
		break;
	case SDLK_f :
		if (!m_fog) {
			glEnable(GL_FOG); 
			m_fog = true;
#ifdef WANT_STATUS
	 		fprintf(stdout, gettext("Fog enabled\n"));
#endif
		} else {
			glDisable(GL_FOG); 
			m_fog = false;
#ifdef WANT_STATUS
	 		fprintf(stdout, gettext("Fog disabled\n"));
#endif
		}
		break;
	case SDLK_k :
		m_eye_angle -= 2.0f;
   	glMatrixMode(GL_PROJECTION);
   	glLoadIdentity();
	   gluPerspective(m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, m_far_cliping);	// 1.0f - to se nesmi sdat < nez 1.0!!!
   	glMatrixMode(GL_MODELVIEW);
#ifdef WANT_STATUS
	 	fprintf(stdout, gettext("View angle changed to %f\n"), m_eye_angle);
#endif	
		break;	
	case SDLK_l :
		m_eye_angle += 2.0f;
   	glMatrixMode(GL_PROJECTION);
   	glLoadIdentity();
	   gluPerspective(m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, m_far_cliping);	// 1.0f - to se nesmi sdat < nez 1.0!!!
   	glMatrixMode(GL_MODELVIEW);
#ifdef WANT_STATUS
	 	fprintf(stdout, gettext("View angle changed to %f\n"), m_eye_angle);
#endif	
		break;	

	case SDLK_h :
		m_far_cliping += 50.0f;
   	glMatrixMode(GL_PROJECTION);
   	glLoadIdentity();
		gluPerspective(m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, m_far_cliping);	// 1.0f - to se nesmi sdat < nez 1.0!!!
   	glMatrixMode(GL_MODELVIEW);
	
		// upravime mlhu, aby se posunula
		glFogf(GL_FOG_START, m_far_cliping - 200.0f);    
		glFogf(GL_FOG_END, m_far_cliping);    
#ifdef WANT_STATUS
	 	fprintf(stdout, gettext("Far clipping changed to %f\n"), m_far_cliping);
#endif	
		break;	
	
	case SDLK_j :
		m_far_cliping -= 50.0f;
   	glMatrixMode(GL_PROJECTION);
   	glLoadIdentity();
	   gluPerspective(m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, m_far_cliping);	// 1.0f - to se nesmi sdat < nez 1.0!!!
   	glMatrixMode(GL_MODELVIEW);
		// upravime mlhu, aby se posunula
		glFogf(GL_FOG_START, m_far_cliping - 200.0f);    
		glFogf(GL_FOG_END, m_far_cliping);      

#ifdef WANT_STATUS
	 	fprintf(stdout, gettext("Far clipping changed to %f\n"), m_far_cliping);
#endif	
		break;		

	}
}


// ozivuje panacka - vraci ho zpet do hry
void GEngineKulic::WantRevive(GKulic *kulic)
{
	if (kulic != NULL && kulic->m_active == false) {
		kulic->Revive(0, 0, -50);
	}
}
