//
// File: GKulic.h
// Created by: berny <(null)>
// Created on: Tue Feb  4 09:54:23 2003
//

#ifndef _GKULIC_H_
#define _GKULIC_H_

#include "GActiveObject.h"

#define MAX_PLAYER_TYPES 1

typedef struct {
	int    model;           // ID 3D modelu -- TODO: tohle tu asi nebude !!!!!
	int    model_gview;     // ID 3D modelu pri zobrazovani dole ve statusu
	
	float base_speed;      // zakladni rychlost panacka
	float base_acceleration; // jak rychle umi panacek zrychlit <0..1>
	float antislide; // kdyz panacek "klouze"  <0..1>
	
	int    max_lives;       // maximalni pocet zovotu
	int    max_shield;      // maximum stitu
	
	int    weapon_prefered; // preferovana zbran -1 == zadna preferovana zbran
	
	float  stand_power;     // sila panacka - pri vypoctu zpetneho razu pri vystrelu - hazi to s postavickou
	
	int    period_ms;      // perioda opakovani cyklu - v milisekundach

	int    weapon_change_ms; // doba potrebna va zmeneni zbrane v ms
	
//	int    sound_???;    // zvuk necho???
} st_kulic_params;

extern st_kulic_params GKulicParams[MAX_PLAYER_TYPES]; // v Params.cpp

#include "GWeapon.h"

class GKulicModel;

// Objek postavicky Kulice
class GKulic : public GActiveObject
{
	public:
		GKulic(GEngine *engine, H3DModel *model3D, st_kulic_params *params);
		~GKulic();
	
		// GKulic interface
		int      m_lives;  // pocet zivotu
		int      m_shield; // stit
		int      m_frags;  // pocet fragu
	
	
		bool LostLives(int lives); // oznamuje hracovi, ze prisel o X zivotu
	
		void Revive(float x, float y, float z); // rika hracovi, ze se muze ozivit na pozici x, y, z 
	
		st_kulic_params m_params; // parametry Kulice
	
		int      m_weaponaID;     // ID zbrane, kterou zrovna Kulic ma
		GWeapon *m_weapona;       // ukazatel na zbran, kterou zrovna Kulic ma
		GWeapon *m_weapons[MAX_WEAPONS]; // vsechny zbrane, ktere muzeme mit
		int      m_weapon_change_ms;   // zbran lze menit, jen kdyz tohle == 0
	
/*	
	bool   m_action1;  -  strelba
	bool   m_action2;  -  meneni zbrane ->
	bool   m_action3;  -  meneni zbrane <-
	bool   m_action4;  -  oziveni
	bool   m_action5;  -  behani
*/

		GKulicModel *m_kulicmodel;

		bool Hitted(GActiveObject *object);


		virtual void DoEvent(); 
		virtual void Render();
};


#endif	//_GKULIC_H_
