// Kulic2

//
// File: GKulicModel.h
// Created by: berny <(null)>
// Created on: Fri Apr 11 17:24:02 2003
//

#include "ph.h"
#include "GKulicModel.h"
#include "H3DModel2.h"


GKulicModel::GKulicModel()
{
	for (int j = 0; j <= WEAPON_TYPES; j++)
		m_body[j] = NULL;
	
	m_legsL = NULL;
	m_legsR = NULL;
	m_legdL = NULL;
	m_legdR = NULL;
	m_legf  = NULL;
	m_leg   = NULL;
	m_legA  = NULL;
	m_shadow = NULL;
	m_dead   = NULL;
	
	m_actualtime = 0;
	m_deadanim = false;
}


GKulicModel::~GKulicModel()
{
	hmodel.RemoveModel(m_leg);
	hmodel.RemoveModel(m_legsL);
	hmodel.RemoveModel(m_legsR);
	hmodel.RemoveModel(m_legf);
	hmodel.RemoveModel(m_legdL);
	hmodel.RemoveModel(m_legdR);
	for (int j = 0; j <= WEAPON_TYPES; j++) {
		hmodel.RemoveModel(m_body[j]);
	}
	hmodel.RemoveModel(m_shadow);
	hmodel.RemoveModel(m_dead);
}

void GKulicModel::InitModels(int ch, int skin)
{
	// jen pro jistotu
	if (ch >= gsetting.m_chars) ch = 0;	

	// okopirujeme si nastaveni
	m_ID = ch;
	m_c = gsetting.m_char[ch];
	

	char s[225], s2[255];
	
	if (skin >= m_c.skins) skin = rand()%m_c.skins;

	sprintf(s, m_c.texturebody, skin+1); // vybereme texturu hlavu podle skinu
	
	
		
	// telo - potrebujeme jich vic, kuli ruznemu zpusobu drzeni zbrane
	for (int j = 0; j <= WEAPON_TYPES; j++) {
		sprintf(s2, m_c.modelbody, j); // vybereme texturu hlavu podle skinu
		m_body[j] = hmodel.LoadModelReTextured(s2, s, "", H3D_DL_MODEL);
	}
			
		
	// dopredne nohy
		m_leg = hmodel.LoadModelReTextured(m_c.modellegs,  s, "", H3D_DL_MODEL);
		m_legsR = hmodel.LoadModelReTextured(m_c.modelslegs, s, "",H3D_DL_MODEL);
		m_legsL = hmodel.LoadModelReTextured(m_c.modelslegs, s, "", H3D_DL_MODEL, true);
		m_legf = hmodel.LoadModelReTextured(m_c.modelflegs, s, "", H3D_DL_MODEL);
		m_legdR = hmodel.LoadModelReTextured(m_c.modeldlegs, s, "", H3D_DL_MODEL);
		m_legdL = hmodel.LoadModelReTextured(m_c.modeldlegs, s, "", H3D_DL_MODEL, true);
	
	// smrt a stin	
		m_dead = hmodel.LoadModelReTextured(m_c.modeldead, s, "", H3D_DL_MODEL);
		m_shadow = hmodel.LoadModel(m_c.modelshadow, H3D_DL_OBJECTS); // H3D_DL_MODEL

}
	
void GKulicModel::AnimateModel(int time, bool f, bool b, bool l, bool r, int lives) // posune animaci nohou o urcity cas
{
	// pri chuzi zpet se jen animace pusti pozadu
	if (b) { f = true; time = -time; bool tmp = l; l = r; r = tmp; }
	
	m_legA = m_leg;
	
	if (f && !l && !r) m_legA = m_legf; // pohyb vpred
	if (l && !f) m_legA = m_legsL; // levy strafe
	if (r && !f) m_legA = m_legsR; // pravy strafe
	if (l && f) m_legA = m_legdL; // levy diagonal
	if (r && f) m_legA = m_legdR; // pravy diagonal

	// smrt
	if ( lives < 0 && m_deadanim == false ) {
		m_deadanim = true;
		m_actualtime = 0;
	}
	
	if ( lives >= 0 ) m_deadanim = false;
	
	// posuneme animaci
	m_actualtime += time;
	
}

void GKulicModel::RenderModel(float x, float y, float z, GWeapon *weapon) // vyrenderuje model - tj. musi byt nastavena poloha atd.
{

// v pripade smrti, kreslime mertvolu misto zbytku panacka	
	if ( m_deadanim ) {
		if ( m_dead != NULL ) {
			m_dead->SetTime(m_actualtime);
			m_dead->Render(x, y, z);
		}

	} else {
		// zbran
		int id = 0;
		if (weapon != NULL) {
			weapon->Render(x, y, z);
			id = weapon->BodyID();
		}
		
		// telo
		if (m_body[id] != NULL) m_body[id]->Render(x, y, z); 
		
		// nohy
		if (m_legA != NULL) {
			m_legA->SetTime(m_actualtime);
			m_legA->Render(x, y, z);
		}
	
		// stin
		if ( m_shadow != NULL ) {
			m_shadow->Render(x, y, z);
		}
	}
}
