//ENGINE

// GObject.cpp: implementation of the GObject class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "GObject.h"
#include "GEngine.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GObject::GObject(GEngine *engine)
{
	m_engine = engine;
	m_want_be_deleted = false;
	m_type = GOBJ_UNKNOWN;
}


GObject::~GObject()
{

}

void GObject::Render()
{

}

void GObject::SelfDelete()
{
	// odhlaseni objektu z enginu
	if (m_engine != NULL) m_engine->RemoveObject(this);

	// fyzicke smazani
	delete this;
}

void GObject::WantBeDeleted()
{
	// aby se nam jeden objekt nezaradil do fronty vicekrat :-)
	if (m_want_be_deleted) return;
	m_want_be_deleted = true;

	// zaslani [pozadavku na smazani, az dobehne aktualni herni smycka
	if (m_engine != NULL) m_engine->WantBeDeleted(this);
	else SelfDelete(); // nebo kdyz nezname engine, tak mu nebudem chybet
}

void GObject::DoEvent()
{

}

