// GRun.h: interface for the GRun class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRUN_H__79921EB9_1C87_4EDB_BF6D_E85256F20DCA__INCLUDED_)
#define AFX_GRUN_H__79921EB9_1C87_4EDB_BF6D_E85256F20DCA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GBase.h"

// Uklada informace o tom, jak dopadla hra - GEngine predava funkci GameEnded
typedef struct {
	bool ended; // zda hra skutecne skoncila (false - byla nasilne ukoncena pomoci ESCAPE)
   int  lives_R; // zivoty praveho hrace
   int  lives_L; // zivoty leveho hrace
} st_game_status;

 
// Zakladni objekt hry - urcuje, zda se rizeni predava menu nebo enginu
class GRun : public GBase  
{
public:
	void KeyUp(Uint8 key);
	virtual void KeyDown(Uint8 key);
	virtual void TimePassed(int milisec); // pohne scenou v zavisloti na case v milisec a zobrazi
	virtual void Render(); // vyrenderovani sceny
	GRun();
	virtual ~GRun();


   // Ukonci program
   void ExitProgram();
  
   // odstratuje hru - jako parametry se predaji kdo co ridi */
   void StartGame();

   // hodi hru do menu
   void StartMenu();
   
   // GEngine oznamuje, ze hra uspesne byla dohrana (smrt, ne stisk escape)
   void GameEnded(st_game_status *game_status);

	GBase  *m_actual; // menu nebo engine

	float  m_game_speed; // konstantou se nasobi pocet uplynulicch ms - ovlivni rychlost hry

   bool   m_running; // urcuje, zda hra stale bezi. Pokud je false, program se ukonci

  	bool   m_loading; // zda se nacitalo. Potom se totiz zavola TimePassed s velkou hodnotou a pokud je nekdo AI - zahraje si trosku navic

};

#endif // !defined(AFX_GRUN_H__79921EB9_1C87_4EDB_BF6D_E85256F20DCA__INCLUDED_)
