//
// File: GSetting.h
// Created by: berny <berny@seznam.cz>
// Created on: Tue Jun 24 22:53:54 2003
//

#include "ph.h"
#include "GSetting.h"
#include "GKulic.h"

GSetting gsetting;


#define MAIN_SETTING_FILE "redeemer.cfg" // jmeno hlavniho konfiguracniho souboru
#define CHARS_FILE "chars"  // jmeno souboru s postavickami
#define MAPS_FILE  "maps"   // jmeno souboru s mapami

GSetting::GSetting()
{	

#ifdef WANT_STATUS
	printf(gettext("         --- REDEERER ---\n  Version 0.03 - betatesting only\n"));
#endif	
	
	
	// nulovani promenych
	m_chars = 0;
	m_maps = 0;
	memset(&m_char, 0, sizeof(m_char));
	memset(&m_map, 0, sizeof(m_map));
	memset(&m_startgame, 0, sizeof(m_startgame));
	memset(&m_main, 0, sizeof(m_main));

	char s[255];
	FILE *f;
	
	
	//hlavni nastaveni
	strcpy(s, MAIN_SETTING_FILE);
	// nacteme nastaveni
	if (find_file(s, false) && (f = fopen(s, "rt"))) {
		// nacteni dat ze souboru
		fscanf(f, "%d %d %d %d %d %d %d", &m_main.resolution_x, &m_main.resolution_y,
 		       &m_main.color_depth, &m_main.fullscreen, &m_main.texture_quality,
				 &m_main.filledpolygons, &m_main.hints);
		fclose(f);
	}	
	else {
		fprintf(stderr, gettext("Unable to open inicialization file %s. Using default valueas.\n"), MAIN_SETTING_FILE);
		m_main.resolution_x = 640;
		m_main.resolution_y = 480;
		m_main.color_depth = 0;
		m_main.fullscreen = 1;
		m_main.texture_quality = 1;
		m_main.filledpolygons = 1;
	}

#ifdef WANT_STATUS
	printf(gettext("Resolution : %d X %d X %d\n"), m_main.resolution_x, m_main.resolution_y, m_main.color_depth);	
	if (m_main.fullscreen) printf(gettext("Fullscreen\n"));	
	else printf(gettext("Windowed\n"));	
	printf(gettext("Texture quality %d Filled polygons %d\n"), m_main.texture_quality, m_main.filledpolygons);
#endif	
	
	// nacitani parametru panacku
	strcpy(s, CHARS_FILE);
	if (!find_file(s, true)) exit(1);

	f = fopen(s, "rt");
	if (f != NULL) {
		while (!feof(f)) {
			fscanf(f, "%s\n", s);
			AddSoldier(s);
		}
		fclose(f);
	} else {
		fprintf(stderr, gettext("Unable to open file %s\n"), CHARS_FILE);
		exit(1);
	}
	if (m_chars == 0) { // zda jsme nasli alespon 1 panacka
		fprintf(stderr, gettext("No characters found in file %s\n"), CHARS_FILE);
		exit(1);
	}
	
	// nacitani parametru map
	strcpy(s, MAPS_FILE);
	if (!find_file(s, true)) exit(1);

	f = fopen(s, "rt");
	if (f != NULL) {
		while (!feof(f)) {
			fscanf(f, "%s\n", s);
			AddMap(s);
		}
		fclose(f);
	} else {
		fprintf(stderr, gettext("Unable to open file %s\n"), CHARS_FILE);
		exit(1);
	}
	if (m_maps == 0) { // zda jsme nasli alespon 1 mapu
		fprintf(stderr, gettext("No maps found in file %s\n"), CHARS_FILE);
		exit(1);
	}
	
	
}


GSetting::~GSetting()
{
	// TODO: put destructor code here
}




// pridani jednoho vojacka do seznamu vojacku
void GSetting::AddSoldier(char* filename)
{
	if (!find_file(filename)) {
#ifdef WANT_STATUS
	printf(gettext("Unable to find character file %s"), filename);		
#endif
		return;
	}
		
	FILE *f = fopen(filename, "rt");
	st_character c;
	if (f != NULL) {
		
		strcpy(c.file, filename);
		fscanf(f, "%d\n", &c.paramsID); // ID parametru panacka 
		fscanf(f, "%d\n", &c.skins);    // pocet skinu panacka 
		fscanf(f, "%s\n", c.name);     // jmeno postavy
		

		// telo
		fscanf(f, "%s\n", c.texturebody); // textura modelu tela
		fscanf(f, "%s\n", c.modelbody);   // jmeno modelu tela
		
		// nohy
		fscanf(f, "%s\n", c.modellegs); // jmeno modelu nohou
		fscanf(f, "%s\n", c.modelflegs); // jmeno modelu nohou - pohyb vpred
		fscanf(f, "%s\n", c.modelslegs); // jmeno modelu nohou - strafe
		fscanf(f, "%s\n", c.modeldlegs); // jmeno modelu nohou - diagonal
		fscanf(f, "%f\n", &c.run_anim);  // koeficient zrychlovai pri behu

		// menu
		fscanf(f, "%s\n", c.mini); // jmeno miniobrazku do menu

		// modely stinu a smrti
		fscanf(f, "%s\n", c.modelshadow); // jmeno modelu se stinem
		fscanf(f, "%s\n", c.modeldead); // jmeno modelu se smrti

		fclose(f);
		
		// test na spravnost parametru v souboru
		if (c.paramsID >= MAX_PLAYER_TYPES || c.paramsID < 0) {
			fprintf(stderr,gettext("Invalid character data from file %s\n"), filename);		
		} else {
			m_chars++;
			m_char.push_back(c);
		}
		
#ifdef WANT_STATUS
		printf(gettext("Loaded characer %s from file %s\n"), c.name, filename);		
#endif
	}		
#ifdef WANT_STATUS
	else 
		printf(gettext("Unable to load (open) character file %s\n"), filename);		
#endif
}

// pridani jedne mapy do seznamu map
void GSetting::AddMap(char* filename)
{
	if (!find_file(filename)) {
#ifdef WANT_STATUS
	printf(gettext("Unable to find map file %s"), filename);		
#endif
		return;
	}
		
	FILE *f = fopen(filename, "rt");
	st_map m;
	if (f != NULL) {
		
		strcpy(m.file, filename);
		fscanf(f, "%s\n", m.name);  // jmeno mapy

		// modely
		fscanf(f, "%s\n", m.basic_model);  // model zakladniho modelu
		fscanf(f, "%s\n", m.ground_model); // model podlahy
		fscanf(f, "%s\n", m.roof_model);   // model strechy
		fscanf(f, "%s\n", m.sky_texture);  // textura oblohy
		// menu
		fscanf(f, "%s\n", m.mini); // jmeno miniobrazku do menu
		
		// nacteni barvy mlhy
		fscanf(f, "%f %f %f %f", &m.fogColor[0], &m.fogColor[1], &m.fogColor[2], &m.fogColor[3]);
		
		fscanf(f, "%s\n", m.collis_model); // kolizni model

		fclose(f);
		
		m_maps++;
		m_map.push_back(m);
		
#ifdef WANT_STATUS
		printf(gettext("Loaded map %s from file %s\n"), m.name, filename);		
#endif
	}	
#ifdef WANT_STATUS
	else 
		printf(gettext("Unable to load (open) mapfile %s\n"), filename);		
#endif
}

// testuje, zda data v m_startgame jsou platna - nepresahuji maxima,...
bool GSetting::StartDataValid()
{
	// kontrola udaju o mape....
	if (m_startgame.mapID >= m_maps || m_startgame.mapID < 0) {
		fprintf(stderr, gettext("Invalid mapID when starting engine\n"));
		return false;
	}	
	
	// kontrola postavicky
	int c = m_startgame.charID;
	if (c >= m_chars || c < 0) {  // model
		fprintf(stderr, gettext("Invalid charID when starting engine\n"));
		return false;
	}	
	if (m_char[c].skins <= m_startgame.skinID || m_startgame.skinID  < 0) { // skin
		fprintf(stderr, gettext("Invalid skinID when starting engine\n"));
		return false;
	}	
	return true;
}
