//
// File: GSetting.h
// Created by: berny <berny@seznam.cz>
// Created on: Tue Jun 24 22:53:54 2003
//

// soubor obsahuje vsechny mozne nastaveni a definice struktur, ktere
// maji neco na svedomi s nastavenim

#ifndef _GSETTING_H_
#define _GSETTING_H_


// striktura s nastavenim hry
// uplne to nejhlavnejsi
typedef struct
{
	int resolution_x;    // x-ovy rozmer obrazovky
	int resolution_y;    // y-ovy rozmer obrazovky
	int color_depth;     // bites per pixel
	int fullscreen;      // 0 == okno, 1 == fullscreen
	int texture_quality; // kvalita textur
	int filledpolygons;  // zda se maji kreslit plne polygony - s texturou
	int hints;           // hinty 0 == fastest,  1 == nicest
} st_mainsetting;


// Nacita vsechna zakladni nastaveni a data hry
// melo by casem delat - pocet panacku a u kazdeho pocet skinu
//                     - pocet a jmena mapArea
//                     - mozna nejake savegame?

typedef struct {
	char  file[255];         // jmeno datoveho souboru
	int   paramsID;          // id parametru postavicky
	int   skins;             // pocet skinu postavicky
	char  name[255];         // jmeno postavicky
	char  texturebody[255];  // textura tela
	char  modelbody[255];    // model tela
	char  modellegs[255];    // model nohou - stojici
	char  modelflegs[255];   // model pro pohyb vpred nohou - forward
	char  modelslegs[255];   // model strafujicich nohou
	char  modeldlegs[255];   // model pro sikme chozeni - diagonal legs
	float run_anim;          // kolikrat se ma zrychlit animovani pri behu
	char  mini[255];         // jmeno obrazku minitexturky do menu
	char  modelshadow[255];       // jmeno modelu se stinem
	char  modeldead[255];         // model se smrti
} st_character;

// stuktura mapy - vse, co je potreba o ni vedet. 
// obsahuje jmena 3DS sek a zakladni nastaveni mapy
// neobsahuje pozice staru a bonusy - to se hleda az pri startu hry
typedef struct {
	char file[255];         // jmeno datoveho souboru
	char name[255];         // jmeno mapy
	char basic_model[255];  // model zakladniho modelu
	char ground_model[255]; // model podlahy - na podlahu je jine nastaveni svetla, takze "necerna" pri ostremuhlu pohledu
	char roof_model[255];   // model strechy - kresli se jen u pohledu blizkemu first person
	char sky_texture[255];  // jmeno textury na oblohu
	char mini[255];         // jmeno minitexturky do menu
	GLfloat fogColor[4];    // barva mlhy
	char collis_model[255]; // model narazu
} st_map;

// pri startu hry z menu se vyplnuje takovato struktura
// ktera se predava do GEngineKulic::StartGame()
// asi tam toho pak bude jeste o hodne vice, ale zatim takhle
// hlavne, az bude multiplayer, tak se to bude muset udelat jinek
typedef struct {
	int  mapID;     // ID mapy, ktera se ma hrat
	int  charID;    // ID postaviky panacka
	int  skinID;    // ID skinu, ktery si hrac vybral
	char name[255]; // jmeno hrace
} st_startgame;

// tohle by melo byt pri navratu - zrejme by tu mel byt seznam 
// hracu a jak dopadli
typedef struct {
	int zaitm_nic;
} st_endgame;;



class GSetting
{
	public:
		GSetting(); // automaticky nacita parametry
		 ~GSetting();
	
		// GSetting interface
	
	//hlavni nastaveni
		st_mainsetting m_main;
	
// postavicky
		int m_chars;
		vector<st_character> m_char;

// mapy
		int m_maps;
		vector<st_map> m_map;
	
// pro ucely hry
		st_startgame m_startgame;
		st_endgame   m_endgame;
		bool StartDataValid(); // testuje, zda data v m_startgame jsou platna - nepresahuji maxima,...
	
	protected:
		
	void AddSoldier(char* filename);
	void AddMap(char* filename);
	
};

extern GSetting gsetting;

#endif	//_GSETTING_H_
