//KULIC2

// GView.cpp: implementation of the GView class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "GView.h"
#include "GEngine.h"
#include "GObject.h"
#include "GKulic.h"
#include "H3DModel2.h"
#include "H3DModelBlendQueue.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GView::GView()
{
	m_cameraID = 0;
	m_aiming = NULL;
}

GView::~GView()
{
	hmodel.RemoveModel(m_aiming);
}

void GView::Render()
{
	// Reset pohledu
	glLoadIdentity();			  	    

	// nastaveni pohledu "kamery" - zalezi na MAX_CAMERA_SETTINGS
	switch (m_cameraID) {
	case 0:
		gluLookAt(m_player->m_position.x - m_player->m_sin_alpha*50,
				 40,
	          m_player->m_position.z + m_player->m_cos_alpha*50,
	          m_player->m_position.x + m_player->m_sin_alpha*20,
				 m_player->m_position.y, 
	          m_player->m_position.z - m_player->m_cos_alpha*20, 0, 1.0, 0);
			break;
	case 1:
		gluLookAt(m_player->m_position.x - m_player->m_sin_alpha*20,
				 10,
	          m_player->m_position.z + m_player->m_cos_alpha*20,
	
	          m_player->m_position.x + m_player->m_sin_alpha*70,
				 m_player->m_position.y, 
	          m_player->m_position.z - m_player->m_cos_alpha*70, 0, 1.0, 0);
			break;
	case 2:
	gluLookAt(m_player->m_position.x - m_player->m_sin_alpha*20 + m_player->m_cos_alpha*5,
				 6,
	          m_player->m_position.z + m_player->m_cos_alpha*20 + m_player->m_sin_alpha*5,
	
	          m_player->m_position.x + m_player->m_sin_alpha*70,
				 m_player->m_position.y, 
	          m_player->m_position.z - m_player->m_cos_alpha*70, 0, 1.0, 0);
			break;
	case 3:
	gluLookAt(m_player->m_position.x - m_player->m_sin_alpha*10,
				 100,
	          m_player->m_position.z + m_player->m_cos_alpha*10,
	
	          m_player->m_position.x + m_player->m_sin_alpha*10,
				 m_player->m_position.y, 
	          m_player->m_position.z - m_player->m_cos_alpha*10, 0, 1.0, 0);
			break;
	case 4:
	gluLookAt(m_player->m_position.x + m_player->m_sin_alpha*20 - m_player->m_cos_alpha*5,
				 0,
	          m_player->m_position.z - m_player->m_cos_alpha*20 - m_player->m_sin_alpha*5,
	
	          m_player->m_position.x - m_player->m_sin_alpha*70,
				 m_player->m_position.y, 
	          m_player->m_position.z + m_player->m_cos_alpha*70, 0, 1.0, 0);
			break;
	case 5:
	gluLookAt(m_player->m_position.x + m_player->m_sin_alpha*25,
				 100,
	          m_player->m_position.z - m_player->m_cos_alpha*25,
	
	          m_player->m_position.x + m_player->m_sin_alpha*35,
				 m_player->m_position.y, 
	          m_player->m_position.z - m_player->m_cos_alpha*35, 0, 1.0, 0);
			break;
	case 6:
	gluLookAt(m_player->m_position.x,
				 100,
	          m_player->m_position.z,
	
	          m_player->m_position.x,
				 m_player->m_position.y, 
	          m_player->m_position.z, 1.0, 0.0, 0.0);
			break;	
	}

	// spocitame zobrazovany kvadr. Vse mimo rovnou vyhodime
	frustum.CalculateFrustum();
	

	// jednoduche zobrazeni vseho - atdy by se asi melo zjistovat, co se opravdu ma zobrazovat
	// TODO
	GObject **o =  &m_engine->m_object[0];
	for (int i = 0; i < m_engine->m_objects; i++, o++)
		if (*o != NULL) (*o)->Render();


	// nakreslime zamerovac
	if ( m_player->m_lives >= 0 && m_aiming != NULL )	{
		glDisable(GL_LIGHTING);
		if ( m_player->RenderRotoMovePushMatrix() ) {
			glTranslatef(0.0, 4.0, 0.0);
//			glScalef(3.0, 3.0, 3.0);
			m_aiming->Render(m_player->m_position.x, m_player->m_position.y, m_player->m_position.z);
			glPopMatrix();
		}
		
/*		
		glPushMatrix();
		htexture.SetNullTexture();
		glColor4ub( 255, 50, 50, 128);
		glEnable(GL_ALPHA_TEST);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // GL_ONE_MINUS_SRC_ALPHA
		glAlphaFunc(GL_ALWAYS, 0.0);
		glEnable(GL_BLEND);
		glBegin(GL_LINES);
			glVertex3d(m_player->m_position.x+4, m_player->m_position.y+4, m_player->m_position.z+4);
			glVertex3d(m_player->m_position.x + m_player->m_sin_alpha*70, 
						  m_player->m_position.y+4,
						  m_player->m_position.z - m_player->m_cos_alpha*70);
		glEnd();
		glPopMatrix();
*/		
		glEnable(GL_LIGHTING);
	}
	
	// vyprazdneni bledqueue
	hblendqueue.RenderQueue();


	glDisable(GL_LIGHTING);
	hfont.InPrintfPrepare();
	
	char s[20];	
	
	sprintf(s, "%d", m_player->m_lives);
	hfont.InPrintf(500, 20, s);	
	
	sprintf(s, "%d", m_player->m_frags);
	hfont.InPrintf(600, 20, s);
	
	sprintf(s, "%d", m_player->m_weapona->m_ammo);
	hfont.InPrintf(400, 20, s);	

	sprintf(s, "%s", m_player->m_weapona->m_params.name);
	hfont.InPrintf(20, 20, s);	
	
	hfont.InPrintfDone();
	glEnable(GL_LIGHTING);

	
	/*
	st_colisioncell *cell = m_player->m_collissys.cell[0];
	int j;

	for(j = 0; j < cell->objects; j++) 
		cell->pobject[j]->Render();


	glBegin(GL_TRIANGLES);
			// zkusime naraz se vsemi trojuhelniky v cellu
			for(j = 0; j < cell->triangles*3; j++) {
				glVertex3f(cell->vPolygons[j].x, cell->vPolygons[j].y, cell->vPolygons[j].z);
			}		
	glEnd();		
		
*/			
}

bool GView::Init(GEngine *engine, GKulic *player)
{
	m_aiming = hmodel.LoadModel("zamer.3ds", H3D_DL_OBJECTS);
	m_player = player;
	m_engine = engine;
	return true;
}

void GView::Move()
{

}
