//KULIC2

//
// File: GWeapon.cpp
// Created by: berny <(null)>
// Created on: Wed Feb  5 07:29:54 2003
//

#include "ph.h"
#include "GWeapon.h"	
#include "GEngine.h"
#include "GShoot.h"
#include "GKulic.h"



GWeapon::GWeapon(GEngine *engine, int weaponID, GKulic *owner)
{
	m_engine = engine;
	m_owner = owner;
	m_params = GWeaponParams[weaponID];
	m_model = hmodel.LoadModel(m_params.modelfile, H3D_DL_MODEL);

	RestoreWeapon();
}


GWeapon::~GWeapon()
{
	hmodel.RemoveModel(m_model);
}


// provedeni jednoho eventu
void GWeapon::DoEvent(int time_passed, bool want_shoot)
{
	// odecitame cas pro nabyjeni
	if (m_reloading > 0) m_reloading -= time_passed;
	
	// zkousime strilet
	if (want_shoot && (m_reloading <= 0) && (m_ammo > 0)) {
		m_ammo--;
		
		// vytvorime novou strelu
		GShoot *shoot = new GShoot(m_engine, &GShootParams[m_params.projectile], m_owner);

		// zjistime pohyb vpred
		shoot->m_forward = true;

		// kopie pozice i pohybu
		shoot->m_position = m_owner->m_position;
		shoot->m_position.y = m_owner->m_position.y + 4;
//		shoot->m_moveing  = m_owner->m_moveing;
		shoot->m_rotation = m_owner->m_rotation;
		
		if (m_params.angle != 0) 
			shoot->m_rotation.y += (rand()%m_params.angle)-(m_params.angle/2);

// odstrceni panacka zpet
		if (m_params.back_power != 0) {
			float alpha = ((double)shoot->m_rotation.y / 360.0) *  (2*PI);
			float sin_alpha = sin(alpha);
			float cos_alpha = cos(alpha);
	
			m_owner->m_moveing.x -=  sin_alpha*m_params.back_power/m_owner->m_params.stand_power;
			m_owner->m_moveing.z +=  cos_alpha*m_params.back_power/m_owner->m_params.stand_power;
//			m_owner->m_sliding.x -=  sin_alpha*m_params.back_power/m_owner->m_params.stand_power;
//			m_owner->m_sliding.z +=  cos_alpha*m_params.back_power/m_owner->m_params.stand_power;
		}

		
		// pridame strelu do enginu
		m_engine->AddObject(shoot);

		// nastavime cas na reloadnuti strely
		m_reloading = m_params.reload_time;
	}
}

// resetujeme zbran TODO: dodelat
void GWeapon::RestoreWeapon()
{
	m_reloading = 0;
	m_ammo = m_params.max_ammo;
	
}

// nakresleni zbrane
void GWeapon::Render(float x, float y, float z)
{
	if (m_model != NULL) m_model->Render(x, y, z);
}

// vraci ID tela, ktere se ma kreslit u zbrane
int  GWeapon::BodyID()
{
	return m_params.bodymodel;
}
