//
// File: GWeapon.h
// Created by: berny <(null)>
// Created on: Wed Feb  5 07:29:54 2003
//

#ifndef _GWEAPON_H_
#define _GWEAPON_H_

#define MAX_WEAPONS 5
#define WEAPON_TYPES 5 // typy zbrani podle drzeni - rozhoduje o tom, jake se k nim bude kreslit telo

typedef struct {
	char   name[15];      // jmeno zbrane
	char   modelfile[64]; // jmeno modelu zbrane
	int    bodymodel;     // cislo modelu telo pro zbran - 1 .. WEAPON_TYPES [ 0 == bezezbrane ]

	int    projectile;    // typ strely - podle st_shoot_params
	int    reload_time;   // cas potrebny k nabyti
	
	int    max_ammo;      // maximalni pocet naboju pro danou zbran
	int    start_ammo;    // pocet naboju pri "oziveni"
	
	int    angle;         // uhel rozptylu strel
	
	float  back_power;    // sila zpetneho razu pri vystrelu - hazi to s postavickou
	
	int    sound_fire;    // zvuk vystrelu
} st_weapon_params;

extern st_weapon_params GWeaponParams[MAX_WEAPONS]; // v Params.cpp

class GKulic;
class GEngine;
class H3DModel;

class GWeapon
{
	public:
		GWeapon(GEngine *engine, int weaponID, GKulic *owner); // ID v st_weapon_params, ukazatel na toho, komu zbran patri
		~GWeapon();
	
		// GWeapon interface
		int	              m_ammo;  // pocet naboju
		st_weapon_params    m_params; // parametry zbrane - mely by byt read-only
	
		int                 m_reloading; // kdyz <= 0, muzeme strilet
		GKulic             *m_owner;     // panacek, ktery drzi zbran
		GEngine            *m_engine;    // ukazatel na engine hry
		H3DModel           *m_model;     // model zbrane
	
		void DoEvent(int time_passed, bool want_shoot); // provede jednu "aktualizaci" zbrane, pripadne strili
		void RestoreWeapon(); // Inicializuje zbran - volat pri oziveni panacka
		void Render(float x, float y, float z); // nakresleni brane
		int  BodyID(); // vraci ID tela, ktere se ma kreslit u zbrane
	
	protected:
		// GWeapon variables
	
};


#endif	//_GWEAPON_H_
