//
// File: H3DModelBlendQueue.h
// Created by: berny <2berny@seznam.cz>
// Created on: Wed Aug 20 22:13:02 2003
//

#include "ph.h"
#include "H3DModelBlendQueue.h"

H3DModelBlendQueue hblendqueue;


H3DModelBlendQueue::H3DModelBlendQueue()
{
	m_enabled = true;
}


H3DModelBlendQueue::~H3DModelBlendQueue()
{

}

// prida objekt na kresleni do fronty
void H3DModelBlendQueue::AddQueue( t3DObject *object,  t3DModel*  model)
{
	// pridame, pokud je dovoleno, jinak rovnou rendernem
	if ( m_enabled == true ) {
		st_bendqueue bq;
		bq.object = object;
		bq.model = model;
		glGetFloatv(GL_MODELVIEW_MATRIX, &bq.matrix[0]);
		m_queue.push(bq);
	} else {
		model->RenderObject(object);
	}
}
		
// vyrenderuje vse, co je ve fronte
void H3DModelBlendQueue::RenderQueue()
{
	glPushMatrix();
	
	// vyprazdnime celou frontu 
	while ( !m_queue.empty() ) {
//		st_bendqueue bq = m_queue[m_queue.size()-1];
//		m_queue.pop_back();
		st_bendqueue bq = m_queue.front();
		m_queue.pop();
		glLoadMatrixf( bq.matrix );
		bq.model->RenderObject(bq.object);
	}
		
	glPopMatrix();
}
