//
// File: H3DModelBlendQueue.h
// Created by: berny <2berny@seznam.cz>
// Created on: Wed Aug 20 22:13:02 2003
//

#ifndef _H3DMODELBLENDQUEUE_H_
#define _H3DMODELBLENDQUEUE_H_

/*
  Dela frontu objektu, ktere chteji polopruhledne kresleni
  musi se totiz kreslit az nakonec, jinak je OpenGL pouziva
  pro ozeravani, coz se nam zrovna moc nelibi :-(
  -- vydava se za frontu, ale ve skutecnosti je to jako zasobnik :-(
*/

#include "H3DModel2.h"
#include <queue>

using namespace std;

typedef struct {
	 t3DObject* object; // objekt z modelu
    t3DModel*  model; // model
	 float      matrix[16]; // matice transformace objektu
} st_bendqueue;

class H3DModelBlendQueue
{
	public:
		H3DModelBlendQueue();
		 ~H3DModelBlendQueue();
	
		// H3DModelBlendQueue interface
	
		// prida objekt na kresleni do fronty
		void AddQueue( t3DObject *object,  t3DModel*  model);
		
		// vyrenderuje vse, co je ve fronte
		void RenderQueue();
	
	protected:
		// H3DModelBlendQueue variables
		bool m_enabled; // zda je fronta zapnuta
	
		queue<st_bendqueue> m_queue; // fronta na kresleni v blendu
};

extern H3DModelBlendQueue hblendqueue;

#endif	//_H3DMODELBLENDQUEUE_H_
