//
// File: HFont.h
// Created by: berny <(null)>
// Created on: Thu Jun 19 06:26:12 2003
//

#include "ph.h"
#include "HFont.h"

HFont hfont;

HFont::HFont()
{
	// TODO: put constructor code here
	m_texture = -1;
	m_dlists = 0;
}


HFont::~HFont()
{
	// TODO: put destructor code here
}


bool HFont::LoadFont(char *filename)
{
	Destroy();

	m_texture = htexture.GetTexture(filename);
	
	::printf("Loading font %s\n", filename);
	
	// Vyroba display listu
	
	float   cx;                                                                                     // Holds Our X Character Coord
	float   cy;                                                                                     // Holds Our Y Character Coord
                                                                                                                                               
   m_dlists = glGenLists(256);                                                           // Creating 256 Display Lists
   glBindTexture(GL_TEXTURE_2D, m_texture);                       // Select Our Font Texture
   for (unsigned int i = 0; i < 256; i++)  {                                        // Loop Through All 256 Lists
		cx=(float)(i%16)/16.0f;                                              // X Position Of Current Character
      cy=(float)(i/16)/16.0f;                                              // Y Position Of Current Character
                                                                                                                                               
      glNewList(m_dlists+i, GL_COMPILE);                                // Start Building A List
      glBegin(GL_QUADS);                                                      // Use A Quad For Each Character
         glTexCoord2f(cx, 1 - cy - 0.0625f);                  // Texture Coord (Bottom Left)
         glVertex2i(0,0);                                                // Vertex Coord (Bottom Left)
         glTexCoord2f(cx + 0.0625f, 1 - cy - 0.0625f);  // Texture Coord (Bottom Right)
         glVertex2i(16, 0);                                               // Vertex Coord (Bottom Right)
         glTexCoord2f(cx+0.0625f,1-cy);                  // Texture Coord (Top Right)
         glVertex2i(16, 16);                                              // Vertex Coord (Top Right)
         glTexCoord2f(cx, 1-cy);                                  // Texture Coord (Top Left)
         glVertex2i(0, 16);                                               // Vertex Coord (Top Left)
         glEnd();                                                                        // Done Building Our Quad (Character)
      glTranslated(10, 0, 0);                                           // Move To The Right Of The Character
      glEndList();                            // Done Building The Display List
   }   
	return true;
}

void HFont::printf(int x, int y, const char *pszFormat/*, ...*/)
{
	InPrintfPrepare();
	
	glLoadIdentity();                                                                       // Reset The Modelview Matrix
   glTranslated(x,y,0);                                                            // Position The Text (0,0 - Bottom Left)

	glColor3f(1.0f, 0.5f, 0.5f);
	
	glCallLists(strlen(pszFormat),GL_BYTE,pszFormat);                     // Write The Text To The Screen

	InPrintfDone();
	
}

void HFont::Destroy()
{
	if (m_dlists != 0) {
		glDeleteLists(m_dlists, 256);
		m_dlists = 0;
	}
	
	if (m_texture != -1) {
		htexture.RemoveTexture(m_texture);
		m_texture = -1;
	}
}

void HFont::InPrintfPrepare()
{
	int set = 1;
	
   if ( set > 1 ) {
		set=1;
   }
	htexture.SetTexture(m_texture);

	glEnable(GL_BLEND);									// Enable Blending
//	glEnable(GL_ALPHA_TEST);
	
//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);					// Select The Type Of Blending
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);					// Select The Type Of Blending
//	glAlphaFunc(GL_GREATER, 0.8);
//	glBlendFunc(GL_ONE, GL_ZERO);					// Select The Type Of Blending

   glDisable(GL_DEPTH_TEST);                                                       // Disables Depth Testing
   glMatrixMode(GL_PROJECTION);                                            // Select The Projection Matrix
   glPushMatrix();                                                                         // Store The Projection Matrix
   glLoadIdentity();                                                                       // Reset The Projection Matrix
   glOrtho(0,640,0,480,-1,1);                                                      // Set Up An Ortho Screen
   glMatrixMode(GL_MODELVIEW);                                                     // Select The Modelview Matrix
   glPushMatrix();                                                                         // Store The Modelview Matrix

   glListBase(m_dlists-32+(128*set));                                          // Choose The Font Set (0 or 1)
}

void HFont::InPrintf(int x, int y, const char *pszFormat/*, ...*/)
{
	glLoadIdentity();                           // Reset The Modelview Matrix
   glTranslated(x,y,0);                // Position The Text (0,0 - Bottom Left)

	glColor3f(1.0f, 0.5f, 0.5f);
	
	glCallLists(strlen(pszFormat),GL_BYTE,pszFormat);    // Write The Text To The Screen
}

void HFont::InPrintfDone()
{
	glDisable(GL_BLEND);   
	glDisable(GL_ALPHA_TEST);
	glMatrixMode(GL_PROJECTION);                                            // Select The Projection Matrix
   glPopMatrix();                                                                          // Restore The Old Projection Matrix
   glMatrixMode(GL_MODELVIEW);                                                     // Select The Modelview Matrix
   glPopMatrix();                                                                          // Restore The Old Projection Matrix
   glEnable(GL_DEPTH_TEST);                                                        // Enables Depth Testing
}
