#ifndef _LIST_ITEM_H_
#define _LIST_ITEM_H_

// sablona polozky obousmerne vazaneho seznamu
// - pro pouziti tam, kde neni treba vsech vyhod seznamu
// - slouzi pro jednoduche zretezeni datovych struktur
template <class T>
struct ListItem{
   ListItem(void) {next=prev=NULL;data=NULL;}
   ListItem(T data) {next=prev=NULL; ListItem::data=data;}
   ListItem(ListItem *prev, ListItem *next){Bind(prev, next);data=NULL;}
   ListItem(ListItem *prev, ListItem *next, T data){
		Bind(prev, next); ListItem::data=data;
	}
   void Bind(ListItem *prev, ListItem *next){
		if ((ListItem::prev = prev)!=NULL) prev->next = this;
		if ((ListItem::next = next)!=NULL) next->prev = this;
   }
   void UnBind(void){
		if (prev != NULL) prev->next = next;
		if (next != NULL) next->prev = prev;
		prev=next=NULL;
	}
   T          data;         // Data 
   ListItem  *prev, *next;  // ukazatele ve spojovem seznamu
};

typedef ListItem<BYTE> ListItemByte;
typedef ListItem<WORD> ListItemWord;
typedef ListItem<int>  ListItemInt;
typedef ListItem<long> ListItemLong;

#endif
