// REDEEMER 
//
// Pravidla pro editaci zdrojaku :
//
// pojmenovavani - zasadne a pouze ANGLICKY
// komentare     - NESETRIT. hodne popisovat. Nove pokud mozno cesky :-)
// odsazovani    - o TAB (3) nebo 3 mezery
// co se musi dodelavat oznacit TODO a co by mohlo se pridat oznacit OPTIONALY
// usnadnuje to pak hledani mist, ktera nejsou dodelana
// Pouzivat zasadne komentare typu // - komentare /*   */ pak pro "vyhazovani" casti kodu
// zpravy v "..." psat zasadne anglicky a okolo napsat gettext("...")

#include "ph.h"
#include "GRun.h"
#include "GEngine.h"
#include "time.h"

// zakladni objekt hry
GRun *gRun = NULL;

// Prehodi FullScreen (Zapne / Vypne)
void ToggleFullScreen()
{
	SDL_Surface *S = SDL_GetVideoSurface();												

	if(!S || (SDL_WM_ToggleFullScreen(S) != 1))							
		fprintf(stderr, gettext("Unable to toggle fullscreen: %s\n"), SDL_GetError());
}

// Nastaveni zakladnich parametru pro OpenGL
void InitGL(int Width, int Height)	        // We call this right after our OpenGL window is created.
{
   glViewport(0, 0, Width, Height);
   glEnable(GL_TEXTURE_2D);               // Povolime textury
   glClearColor(0.0f, 0.0f, 0.0f, 0.0f);	// Nastavime barvu pozadi na cernou
   glClearDepth(1.0);				         // povolime mazani hloubkove bufferu
   glDepthFunc(GL_LESS);			      	// The Type Of Depth Test To Do
   glEnable(GL_DEPTH_TEST);					// Povolime testovani hloubky
	
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();				// Reset The Projection Matrix

   gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,1.0f,250.0f);	// 1.0f - to se nesmi sdat < nez 1.0!!!
	SCREEN_WIDTH = (GLfloat)Width;
	SCREEN_HEIGHT = (GLfloat)Height;

   glMatrixMode(GL_MODELVIEW);
	
	// OPTIONALY : zkusime zapnout odstranovani zadnich sten objektu - treba se zrychli vypocet
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	
	// OPTIONALY : umoznuje vykreslovat jen pomoci obrysu trojuhelniku
	if (gsetting.m_main.filledpolygons == 0) 
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	else
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

	// OPTIONALY : Muzeme zkusit zrychlit kresleni :-)
if (gsetting.m_main.hints == 0) {
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST); // NICEST, DONT_CARE
	glHint(GL_POINT_SMOOTH_HINT, GL_FASTEST);   // NICEST, DONT_CARE
	glHint(GL_LINE_SMOOTH_HINT, GL_FASTEST);    // NICEST, DONT_CARE
	glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST); // NICEST, DONT_CARE
	glHint(GL_FOG_HINT, GL_FASTEST);            // NICEST, DONT_CARE
}
else {
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST); // NICEST, DONT_CARE
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);   // NICEST, DONT_CARE
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);    // NICEST, DONT_CARE
	glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST); // NICEST, DONT_CARE
	glHint(GL_FOG_HINT, GL_NICEST);            // NICEST, DONT_CARE
}

	GLfloat fogColor[4] = {0.0f,0.0f,0.0f,1.0f};            // Fog Color
	glFogi(GL_FOG_MODE, GL_LINEAR);                        // Fog Mode GL_EXP, GL_EXP2, GL_LINEAR
	glFogfv(GL_FOG_COLOR, fogColor);                                       // Set Fog Color
	glFogf(GL_FOG_DENSITY, 10.0f); // pouze pro GL_EXP...
	glFogf(GL_FOG_START, 100.0f);                                            // Fog Start Depth    
	glFogf(GL_FOG_END, 200.0f);                                              // Fog End Depth      
//	glEnable(GL_FOG);                                                      // Enables GL_FOG           

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);

	// osvetlovani materialu - test
	GLfloat light[4] = {0.9f,0.9f,0.9f,1.0f};            // Fog Color
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, light);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, light);

	glShadeModel(GL_SMOOTH);					// Enables Smooth Color Shading
	// glShadeModel(GL_FLAT);					   // Enables flat Color Shading  - melo by byt rychlejsi
 
	glEnable(GL_LIGHT0);								// Turn on a light with defaults set
	glLightfv(GL_LIGHT0, GL_AMBIENT, light);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light);
	glEnable(GL_LIGHTING);

	glEnable(GL_COLOR_MATERIAL);						// Allow color
	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);

	// Nastavime blending - jako u stromu
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // GL_ONE_MINUS_SRC_ALPHA
//	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
//	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0.2);
//	glEnable(GL_BLEND);

	// nastavime kvalitu generovani textur
	htexture.SetTextureGeneratingQuality(gsetting.m_main.texture_quality);

	char *extension = (char*)glGetString(GL_EXTENSIONS);
	
	printf("GL Extensions: %s\n", extension);

	
	hfont.LoadFont("font.bmp");
	
}

// Inicializace SDL
void	InitSDL()
{
	// Inicializace generatoru nahodnych cisel
	srand(time(NULL));

   // Inicializace SDL grafiky a SDL Timeru 
   if ( SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER ) < 0 ) {
      fprintf(stderr, gettext("Unable to initialize SDL: %s\n"), SDL_GetError());
      exit(1);
	}

	// nastaveni funkce pri volani exit();
	atexit(SDL_Quit);

	// chceme doublebuffering s openGL
   SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );


	// Nastavime velikost a styl okna
	unsigned int flags = SDL_OPENGL;// |SDL_RESIZABLE; // |SDL_RESIZABLE
	if (gsetting.m_main.fullscreen) flags |= SDL_FULLSCREEN;

	// vytvorime okno
   if ( SDL_SetVideoMode(gsetting.m_main.resolution_x, gsetting.m_main.resolution_y, gsetting.m_main.color_depth, flags) == NULL ) {
		fprintf(stderr, gettext("Unable to create OpenGL screen: %s\n"), SDL_GetError());
		SDL_Quit();
		exit(2);
	}
	
	// Nastaveni titulku okna
	SDL_WM_SetCaption(gettext("Redeemer ( Kulic II )"), NULL);

	// zruseni mysi
	SDL_ShowCursor(SDL_DISABLE);
}

// Inicializuje objekt gRun
void InitGame()
{
	// vytvorime novy onjekt hry
	gRun = new GRun;

	if (gRun == NULL) {
		fprintf(stderr, gettext("Unable to init game - creating of GRun failed\n"));
		SDL_Quit();
		exit(3);
	}

	// hodime hru do menu (kam jinam)
	gRun->StartMenu();	
}

// Zpracovava udalosti. GRun nikdy neni == NULL, ale pro jistotu stejne testujeme
bool ProcessEvents()
{
	SDL_Event event;
   while ( SDL_PollEvent(&event) ) {
		switch (event.type) {
      
		case SDL_QUIT :       // uzivatel si preje ukoncit aplikace
			return false;
			break;

		case SDL_KEYDOWN :    // stisknuta klavesa
			switch (event.key.keysym.sym) {
      	case SDLK_F1 : // pomoci F1 prepiname mezi FullScreenem a normalem - jen Linux
       		ToggleFullScreen();
         	break;
         default :
				if (gRun != NULL) gRun->KeyDown(event.key.keysym.sym);
				break;
			}
			break;

		case SDL_KEYUP :      // uvolnena klavesa
			if (gRun != NULL) gRun->KeyUp(event.key.keysym.sym);
			break;

      case SDL_VIDEORESIZE : // zmena velikosti okna
			InitGL(event.resize.w, event.resize.h);
			break;

      case SDL_VIDEOEXPOSE : // potreba prekreslit okno
			if (gRun != NULL) gRun->Render();
			break;
      }
   }
	return true;
}

// Funkce main - co dodat  /*argc*/ jsou zakomentovane, aby prekladac nemel kecy :-)
int main(int /*argc*/, char ** /*argv*/ ) 
{

//  vypis argumentu
//	for (int i = 0; i < argc; i++)
//		fprintf(stdout, "param %d %s\n", i, argv[i]);

	// Nacteni nastaveni
#ifdef WANT_STATUS
	fprintf(stdout, gettext("Setting Loaded.\n"));
#endif

	// Inicializace knihovny SDL
	InitSDL();
#ifdef WANT_STATUS
	fprintf(stdout, gettext("SDL Inicialized.\n"));
#endif

	// Inicializace OpenGL
	InitGL(gsetting.m_main.resolution_x, gsetting.m_main.resolution_y);
#ifdef WANT_STATUS
	fprintf(stdout, gettext("OpenGL Inicialized.\n"));
#endif

	
	// Inicializace hry
	InitGame();
#ifdef WANT_STATUS	
	fprintf(stdout, gettext("Game Inicialized.\n"));
#endif

	// casovani hry
	int time1 = SDL_GetTicks();
	int time2 = SDL_GetTicks();

	// Hlavni herni smycka
#ifdef WANT_STATUS
	fprintf(stdout, gettext("Entering main game loop.\n"));
#endif

	while ((gRun != NULL) && (gRun->m_running)) {

		// kdyz nedopadne dobre obsluha udalosti, program se ukonci
		if (!ProcessEvents()) break;

		// zjistime novy cas
		time2 = SDL_GetTicks();
		
		// pockame, az poskoci cas alespon o 1ms. jinak dalsi volani 
		// vubec nemaji smysl, protoze se scena nemohla zmenit (nemela kdy)
		if (time2 - time1 > 1) {
			// probehne jedna smycka aplikace
			if ((SDL_GetAppState() & SDL_APPACTIVE) && (gRun != NULL)) {
				gRun->TimePassed(time2 - time1);
				gRun->Render();
			}
			// zapamatujeme si stary cas
			time1 = time2;
		}

		// OPTIONALY
		// SDL_Delay(2); // ceka X milisekund - muze tu byt, aby nepoziralo veskery vykon pocitace....
		
   } // while ((gRun != ...

 #ifdef WANT_STATUS
 	fprintf(stdout, gettext("Delleting all..\n"));
#endif

   
   // odstraneni objektu hry
   SAFE_DELETE(gRun);

   // ukonceni SDL
	SDL_Quit();

	// konec programu
#ifdef WANT_STATUS
	fprintf(stdout, gettext("OK\nEnd.\n"));
#endif
	
	return 1;
}
