//NEPOUZITO
/***************************************************************************
                          mvictory.cpp  -  description
                             -------------------
    begin                : P ?j 4 2002
    copyright            : (C) 2002 by Berny
    email                : 2berny@seznam.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ph.h"
#include "mvictory.h"

MVictory::MVictory(GRun *run, st_game_status *game_status)
{
	m_run = run;
	m_back_ground = -1;
	m_time = 0;

	memcpy(&m_game_status, game_status, sizeof(st_game_status));

	// remiza
	if (game_status->ended == false ||
	   (game_status->lives_L > 0 && game_status->lives_R > 0) ||
	   (game_status->lives_L <= 0 && game_status->lives_R <= 0))  {
	   m_back_ground = htexture.GetTexture("remiza.jpg");
	   return;
	}

	// vyhral levy
	if (game_status->lives_L > 0) {
	   m_back_ground = htexture.GetTexture("won_l.jpg");
	   return;
	}
	
	// vyhral pravy
	if (game_status->lives_R > 0) {
	   m_back_ground = htexture.GetTexture("won_r.jpg");
	   return;
	}

	// tady je neco hodne spatne :-)
	fprintf(stderr, "Incorrect data returned from GEngine. File : %s, Line : %d\n", __FILE__, __LINE__);
}

MVictory::~MVictory()
{
   htexture.RemoveTexture(m_back_ground);
}

// zobrazi vysledky
void MVictory::Render()
{
	glLoadIdentity();
	glTranslatef(0.0f, 0.0f, -2.2f);

	// Nastaveni textury pozadi
	htexture.SetTexture(m_back_ground);
 	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -1.1f,   1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  1.1f,   1.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  1.1f,  -1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -1.1f,  -1.0f, 0.0f);
	glEnd();
}

// reaguje na stisk klavesy - ukoncenim a skokem do menu
void MVictory::KeyDown(Uint8 /*key*/)
{
	if (m_time > MVICTORY_MINIMAL_TIME)
		m_run->StartMenu();	
}

void MVictory::TimePassed(int milisec)
{
	m_time += milisec;
}
