#ifndef _PRECOMPILED_HEADER_
#define _PRECOMPILED_HEADER_

// Na Linuxu se objevuje soubor config.h, ktery muze obsahovat zajimave informace o systemu
#ifdef HAVE_CONFIG_H 
#include <config.h>
#endif   


// zapina system na pocitani trojuhelniku 
// na frame a ruzne dalsi statistiky
#define WANT_STATISTIC

// kdyz je tetnto define aktivni, tak se ruzne vypisuje, co zrovna engine dela
// pro release verzi je naprosto zbytecne, ale je to herzke :-)
#define WANT_STATUS

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif


// BERNY: tohle je kuli nasemu kamaradovi Linuxovi
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// zakladni matematika a STL
#include <math.h>
#include <fstream>
#include <vector>
using namespace std;


#ifndef _MSC_VER
#define _MSC_VER 0
#endif

// SDL-ko
/*
#ifdef WIN32
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_opengl.h"
#else
*/
#include "SDL/SDL.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_opengl.h"
//#endif

#ifndef MAX_PATH
#define MAX_PATH 512 // jak dlouhe maji byt pametove rezervy na jmena souboru i s cestou
#endif

// BERNY: tohle bylo v mydefs.h
#define SAFE_DELETE(x) if(x) {delete x; x = NULL;} // Object
#define SAFE_DELETEA(x) if(x) {delete [] x; x = NULL;} // Array

// BERNY: aby to slo kompilvat pod linuxem
#ifndef FALSE
#define FALSE               0
#endif

#ifndef TRUE
#define TRUE                1
#endif

#ifndef DWORD
typedef unsigned long       DWORD;
#endif

#ifndef BOOL
typedef int                 BOOL;
#endif

#ifndef BYTE
typedef unsigned char       BYTE;
#endif

#ifndef WORD
typedef unsigned short      WORD;
#endif

#ifndef FLOAT
typedef float               FLOAT;
#endif

#ifndef WIN32
// TODO :: musime definovat ten ULONGLONG
#ifndef ULONGLONG
typedef unsigned long long               ULONGLONG;
#endif
#endif


// uz konecne nase hedry
#include "GSetting.h"     // prvni je include s nastavenim
#include "3DMath.h"       // 3D matematika (pocitani s vektory)
#include "HTextureStore.h" // trida pro zpravu textur
#include "H3DModelStore.h"  // trida pro zpravu modelu
#include "HFrustum.h"     // na orezavani toho, co vubec neni v zobrazovacim prostoru
#include "global_func.h"  // pridame globalni funkce
#include "HFont.h"       // objekt na praci s fonty


// Neco pro gettext - aby bylo "multilaguage"
#ifndef gettext
#define gettext(string) (string)
#endif

#endif
